<!-- eslint-disable vue/no-v-html -->
<template>
  <div class="relative-position">
    <el-tiptap
      v-model="value.doc"
      :editor-properties="editorProperties"
      :placeholder="editorProperties.placeholder"
      :char-counter-count="false"
      :extensions="extensions"
      :show-menubar="false"
      :width="890"
      @onInit="init"
      @onTransaction="transaction"
    />

    <div class="title-area" />

    <div
      class="numbering"
      v-html="numbering"
    />

    <div
      class="text-center text-bold text-grey-8 q-pt-md"
      v-text="'Máximo de 30 linhas.'"
    />
  </div>
</template>

<script>
import { Doc, Paragraph, Text, Indent, TextHighlight } from 'element-tiptap'
import Comment from '../composing/form-comment'
import { colors } from 'quasar'

const formFactory = JSON.stringify({
  comment: null,
  category: ''
})

const { getPaletteColor, hexToRgb } = colors
const defaultColors = [getPaletteColor('grey-5')]

export default {
  name: 'EditorTiptap',
  props: {
    value: {
      type: Object,
      required: true
    },
    categories: {
      type: Array,
      required: true
    }
  },
  data () {
    return {
      editor: null,
      editorProperties: {
        placeholder: 'Clique para escrever sua redação...',
        autoFocus: true
      },
      extensions: [
        new Doc(),
        new Paragraph(),
        new Text(),
        new Indent(),
        new TextHighlight({ bubble: true, colors: defaultColors })
      ],
      formComment: JSON.parse(formFactory),
      isOpen: false
    }
  },
  computed: {
    numbering () {
      let numbers = ''

      for (let i = 1; i <= 30; i++) {
        numbers += `<div>${i}.</div>`
      }

      return numbers
    }
  },
  watch: {
    value: {
      deep: true,
      handler () {
        this.sanitize()
      }
    }
  },
  methods: {
    init ({ editor }) {
      this.editor = editor
    },
    transaction ({ editor }) {
      this.editor = editor

      if (this.isOpen) {
        return undefined
      }

      const { highlightColor } = editor.activeMarkAttrs.text_highlight
      const { selection, doc } = editor.state.tr

      if (!highlightColor || !selection || !doc) {
        return undefined
      }

      const { $cursor, from, to, $from: { pos, textOffset } } = selection
      const anchor = pos - textOffset
      let selected

      if ($cursor) {
        const { nodeBefore, nodeAfter } = $cursor
        const textBefore = nodeBefore ? nodeBefore.text : ''
        const textAfter = nodeAfter ? nodeAfter.text : ''

        selected = textBefore + textAfter
      } else if (from && to && highlightColor === defaultColors[0]) {
        selected = doc.textBetween(from, to, ' ')
      }

      if (!selected || !anchor) {
        return undefined
      }

      const key = `${selected}_${anchor}`

      if (this.value.comments[selected]) {
        this.formComment.comment = this.value.comments[selected].comment
        this.formComment.category = this.categories.find((category) => category.id === this.value.comments[selected].categoryId)
      } else if (this.value.comments[key]) {
        this.formComment.comment = this.value.comments[key].comment
        this.formComment.category = this.categories.find((category) => category.id === this.value.comments[key].categoryId)
      }

      this.isOpen = true

      this.$q.dialog({
        component: Comment,
        options: this.categories,
        value: this.formComment,
        parent: this
      }).onOk((data) => {
        this.comment(editor, highlightColor, doc.toJSON(), selected, anchor, data)
      }).onDismiss(() => {
        editor.setContent(editor.getHTML(), true)
        this.formComment = JSON.parse(formFactory)
        this.isOpen = false
      })
    },
    comment (editor, highlightColor, doc, selected, anchor, data) {
      doc.content.forEach((paragraph) => {
        if (paragraph.content) {
          paragraph.content.forEach((content) => {
            if (content.text === selected) {
              const html = editor.getHTML()
              const text = this.parse(selected).body.innerHTML
              let backgroundColor = data.category.color
              const key = `${selected}_${anchor}`

              Object.keys(this.value.comments).forEach((comment) => {
                if (!this.value.comments[comment].id) {
                  return undefined
                }

                const [commentSelected, commentColor] = this.value.comments[comment].id.split('_')

                if (comment !== key && commentSelected === selected && commentColor === backgroundColor) {
                  backgroundColor = this.hexIncrement(backgroundColor)
                }
              })

              this.value.comments[key] = {
                id: `${selected}_${backgroundColor}`,
                categoryId: data.category.id,
                comment: data.comment
              }
              this.color(html, highlightColor, backgroundColor, text)
            }
          })
        }
      })
    },
    hexIncrement (color) {
      const chunk = color.slice(0, 6)
      const hex = color.slice(-1)
      let dec = parseInt(hex, 16)

      if (dec === 15) {
        dec--
      } else {
        dec++
      }

      const newHex = dec.toString(16)

      return chunk + newHex
    },
    async sanitize () {
      const elements = this.parse(this.value.doc).getElementsByTagName('span')
      const comments = Object.keys(this.value.comments)
      const marks = await Promise.all(Object.keys(this.value.comments).map(async (comment) => {
        try {
          const [_selected, _color] = this.value.comments[comment].id.split('_')

          return `${_selected}_${this.hex2rgb(_color)}`
        } catch (e) {
          const { categoryId } = this.value.comments[comment]
          const _color = await this.getColor(categoryId) ?? ''

          return `${comment}_${this.hex2rgb(_color)}`
        }
      }))

      const keys = []

      for (let i = 0; i < elements.length; i++) {
        const selected = elements[i].innerText
        const { backgroundColor } = elements[i].style
        const id = `${selected}_${backgroundColor}`

        keys.push(id)
      }

      keys.forEach((key) => {
        const [_text, _backgroundColor] = key.split('_')

        if (!marks.includes(key) && _backgroundColor !== this.hex2rgb(defaultColors[0])) {
          this.color(this.value.doc, _backgroundColor, defaultColors[0], _text)
          this.$emit('save')
        }
      })

      comments.forEach((key) => {
        if (!this.value.comments[key].id) {
          const tempKeys = keys.map(_key => _key.split('_')[0])

          if (!tempKeys.includes(key)) {
            delete this.value.comments[key]
          }

          return undefined
        }

        const [selected, color] = this.value.comments[key].id.split('_')
        const backgroundColor = this.hex2rgb(color)
        const id = `${selected}_${backgroundColor}`

        if (!keys.includes(id)) {
          delete this.value.comments[key]
        }
      })
    },
    parse (html) {
      return new DOMParser().parseFromString(html, 'text/html')
    },
    color (html, initialColor, finalColor, text) {
      const code = (color, text) => `<span style="background-color: ${color};">${text}</span>`
      const updatedHtml = html.replace(code(initialColor, text), code(finalColor, text))

      this.editor.setContent(updatedHtml, true)
    },
    hex2rgb (hexColor) {
      try {
        const { r, g, b } = hexToRgb(hexColor)
        return `rgb(${r}, ${g}, ${b})`
      } catch (e) {
        return hexColor
      }
    },
    async getColor (categoryId) {
      try {
        const axiosConfig = {
          method: 'GET',
          url: `/Categories/${categoryId}`,
          params: {
            filter: {
              fields: ['color']
            }
          }
        }

        return this.$axios(axiosConfig).then(R => R.data.color)
      } catch (e) {
        return undefined
      }
    }
  }
}
</script>

<style lang="sass">
.el-tiptap-editor > .el-tiptap-editor__content
  background-image: repeating-linear-gradient(#fff 0px, #fff 24px, #4682b4 25px)
  box-shadow: 0px 0px 5px 0px #888
  -webkit-background-size: 100% 32px
  -moz-background-size: 100% 32px
  -ms-background-size: 100% 32px
  background-size: 100% 32px
  padding: 32px 10px 20px 55px
  font-family: 'IndieFlower'
  border-radius: 5px
  min-height: 1015px
  line-height: 1.55
  font-size: 21px
</style>
